<?php

defined('_JEXEC') or die('Restricted access');

/**
 *
 * a special type of 'Pagadito':
 * @author The Pagadito Development Team
 * @version 1.0.0
 * @package VirtueMart
 * @subpackage payment
 * @copyright Copyright (C) 2010-2012 Pagadito. All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.html GNU/LGPL
 *
 * http://virtuemart.org
 */
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
if (!class_exists('Pagadito'))
    require('Pagadito_API.php');

class plgVmPaymentPagadito extends vmPSPlugin {

    // instance of class
    public static $_this = false;

    function __construct(& $subject, $config) {
        //if (self::$_this)
        //   return self::$_this;
        parent::__construct($subject, $config);

        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $this->_tablepkey = 'id'; //virtuemart_pagadito_id';
        $this->_tableId = 'id'; //'virtuemart_pagadito_id';
        $varsToPush = array(
            'pagadito_uid' => array('', 'char'),
            'pagadito_wsk' => array('', 'char'),
            'pagadito_sandbox_uid' => array('', 'char'),
            'pagadito_sandbox_wsk' => array('', 'char'),
            'sandbox' => array(1, 'int'),
            'payment_logos' => array('', 'char'),
            'payment_currency' => array('', 'int'),
            'min_amount' => array('1', 'int'),
            'max_amount' => array('9999', 'int'),
            'cost_per_transaction' => array('0', 'int'),
            'cost_percent_total' => array('0', 'int'),
            'status_pending' => array('', 'char'),
            'status_success' => array('', 'char'),
            'status_canceled' => array('', 'char')
        );

        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }

    public function getVmPluginCreateTableSQL() {

        return $this->createTableSQL('Payment Pagadito Table');
    }

    function getTableSQLFields() {

        $SQLfields = array(
            'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(1) UNSIGNED',
            'order_number' => ' char(64)',
            'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
            'payment_name' => 'varchar(5000)',
            'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
            'payment_currency' => 'char(3) ',
            'cost_per_transaction' => 'decimal(10,2)',
            'cost_percent_total' => 'decimal(10,2)',
            'pagadito_token' => 'char(50)',
            'pagadito_response_payment_date' => 'char(28)',
            'pagadito_response_payment_status' => 'char(50)',
            'pagadito_response_pending_reason' => 'char(50)'
        );
        return $SQLfields;
    }

    function plgVmConfirmedOrder($cart, $order) {

        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $session = JFactory::getSession();
        $return_context = $session->getId();
        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
        if (!class_exists('VirtueMartModelCurrency'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
        $new_status = '';
        $usrBT = $order['details']['BT'];
        $address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);
        if (!class_exists('TableVendors'))
            require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
        $vendorModel = VmModel::getModel('Vendor');
        $vendorModel->setId(1);
        $vendor = $vendorModel->getVendor();
        $vendorModel->addImages($vendor, 1);
        $this->getPaymentCurrency($method);
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();

        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
        if ($totalInPaymentCurrency <= 0) {
            vmInfo(JText::_('VMPAYMENT_PAGADITO_PAYMENT_AMOUNT_INCORRECT'));
            return false;
        }
        /* UID */
        $pagadito_uid = $this->_getMerchantUID($method);
        if (empty($pagadito_uid)) {
            vmInfo(JText::_('VMPAYMENT_PAGADITO_MERCHANT_UID_NOT_SET'));
            return false;
        }
        /* WSK */
        $pagadito_wsk = $this->_getMerchantWSK($method);
        if (empty($pagadito_wsk)) {
            vmInfo(JText::_('VMPAYMENT_PAGADITO_MERCHANT_WSK_NOT_SET'));
            return false;
        }
        /* INSTANCIAR EL OBJETO */
        $Pagadito = new Pagadito($pagadito_uid, $pagadito_wsk);
        /* ACTIVAR SANDBOX */
        if ($method->sandbox) {
            $Pagadito->mode_sandbox_on();
        }
        /* CONECTAR CON PAGADITO */
        if ($Pagadito->connect()) {
            /* OBTENER VALUE */
            $token = $Pagadito->get_rs_value();
            /* PREPARAMOS LOS DATOS PARA INGRESAR EN LA DB */
            $dbValues['order_number'] = $order['details']['BT']->order_number;
            $dbValues['payment_name'] = $this->renderPluginName($method, $order);
            $dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
            $dbValues['payment_currency'] = $method->payment_currency;
            $dbValues['payment_order_total'] = $totalInPaymentCurrency;
            $dbValues['pagadito_token'] = $token;
            /* INGRESAR DATOS EN LA DB */
            $this->storePSPluginInternalData($dbValues);
            /* CAMBIAR MONEDA A LA METODO */
            switch ($currency_code_3) {
                case "CRC" :
                    $Pagadito->change_currency_crc();
                    break;

                case "GTQ" :
                    $Pagadito->change_currency_gtq();
                    break;

                case "HNL" :
                    $Pagadito->change_currency_hnl();
                    break;

                case "NIO" :
                    $Pagadito->change_currency_nio();
                    break;

                case "PAB" :
                    $Pagadito->change_currency_pab();
                    break;

                case "DOP" :
                    $Pagadito->change_currency_dop();
                    break;
            }
            /* AGREGAR DETALLE DE LA CARRETILLA */
            foreach ($cart->products as $key => $product) {
                $Pagadito->add_detail($product->quantity, substr(strip_tags($product->product_name), 0, 100), round($cart->pricesUnformatted[$key]['salesPrice'], 2), NULL);
            }
            /* AGREGAR DESCUENTO POR CUPON */
            if (abs($order['details']['BT']->coupon_discount) > 0.0) {
                $Pagadito->add_detail(1, JText::_('VMPAYMENT_PAGADITO_DISCOUNT')." (".utf8_decode($order['details']['BT']->coupon_code).")", $order['details']['BT']->coupon_discount, NULL);
            }
            /* AGREGAR SHIPPING */
            if ($cart->pricesUnformatted['shipmentValue']) {
                $Pagadito->add_detail(1, JText::_('VMPAYMENT_PAGADITO_SHIPMENT_PRICE'), $cart->pricesUnformatted['shipmentValue'], NULL);
            }
            /* AGREGAR COSTO POR TRANSACCION */
            if ($cart->pricesUnformatted['paymentValue']) {
                $Pagadito->add_detail(1, JText::_('VMPAYMENT_PAGADITO_PAYMENT_PRICE'), $cart->pricesUnformatted['paymentValue'], NULL);
            }

            /* EJECUTAR TRANSACCION */
            $Pagadito->exec_trans($order['details']['BT']->order_number);
        }
        /* ERROR DE CONEXION CON PAGADITO */
        /* MOSTRAR ERROR */
        vmWarn(JText::_('VMPAYMENT_PAGADITO_PAYMENT_STATUS_CANCELED'). " " . $Pagadito->get_rs_code() . " -> " . $Pagadito->get_rs_message(), $order['details']['BT']->order_number);
        /* NO BORRAR EL EL CARRITO, NO ENVIAR EMAIL Y NO REDIRECCIONAR */
        $html = '';
        $cart->_confirmDone = false;
        $cart->_dataValidated = false;
        $cart->setCartIntoSession();
        JRequest::setVar('html', $html);        
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);
        $paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnPaymentResponseReceived(&$html) {
        if (!class_exists('VirtueMartCart'))
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
        if (!class_exists('shopFunctionsF'))
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
        $pagadito_token = JRequest::getString('token', 0);
        vmdebug('PAGADITO plgVmOnPaymentResponseReceived', $pagadito_token);
        /* OBTENER EL PAYMENT ID Y EL ORDER NUMBER */
        $q = 'SELECT `virtuemart_paymentmethod_id`, `order_number` FROM `#__virtuemart_payment_plg_pagadito` WHERE `pagadito_token` = "' . $pagadito_token . '" ';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $plg_pagadito = $db->loadObject();
        // the payment itself should send the parameter needed.
        $virtuemart_paymentmethod_id = $plg_pagadito->virtuemart_paymentmethod_id;
        $order_number = $plg_pagadito->order_number;
        //$vendorId = 0;
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return null;
        }
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number) )) {
            return null;
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id) )) {
            return null;
        }
        /* REVISAR ESTATUS DE PAGADITO */
        /* OBTENER UID */
        $pagadito_uid = $this->_getMerchantUID($method);
        if (empty($pagadito_uid)) {
            vmInfo(JText::_('VMPAYMENT_PAGADITO_MERCHANT_UID_NOT_SET'));
            return false;
        }
        /* OBTENER WSK */
        $pagadito_wsk = $this->_getMerchantWSK($method);
        if (empty($pagadito_wsk)) {
            vmInfo(JText::_('VMPAYMENT_PAGADITO_MERCHANT_WSK_NOT_SET'));
            return false;
        }
        /* INSTANCIAR EL OBJETO */
        $Pagadito = new Pagadito($pagadito_uid, $pagadito_wsk);
        /* ACTIVAR SANDBOX */
        if ($method->sandbox) {
            $Pagadito->mode_sandbox_on();
        }
        /* CONECTAR CON PAGADITO */
        $Pagadito->connect();
        /* PREGUNTAR ESTATUS */
        $Pagadito->get_status($pagadito_token);
        /* OBTENER DE LA TRANSACCION */
        $pagadito_data["payment_date"] = $Pagadito->get_rs_datetime();
        $pagadito_data["payment_status"] = $Pagadito->get_rs_status();
        $pagadito_data["pending_reason"] = $Pagadito->get_rs_message();
        /*         * ******************************************************************* */
        /* GUARDAR LOS DATOS EN EL METODO DE PAGO */
        $this->_storePagaditoInternalData($method, $pagadito_data, $virtuemart_order_id, $order_number);
        /* OBTENER UNA ORDEN MODELO */
        $modelOrder = VmModel::getModel('orders');
        /* ARRAY PARA PONER LOS DATOS ACTUALIZADOS DE LA ORDEN */
        $order = array();
        /*         * ******************************************************************* */
        /* VALIDAR ESTATUS */
        switch ($Pagadito->get_rs_status()) {
            
            case "REGISTERED":
                
                $order['customer_notified'] = 1;
                $order['order_status'] = $method->status_pending;
                $order['comments'] = JText::sprintf('VMPAYMENT_PAGADITO_PAYMENT_STATUS_PENDING', $order_number);
                break;
            
            case "COMPLETED":
                
                $order['customer_notified'] = 1;
                $order['order_status'] = $method->status_success;
                $order['comments'] = JText::sprintf('VMPAYMENT_PAGADITO_PAYMENT_STATUS_CONFIRMED', $order_number);
                break;
            
            case "FAILED":
            case "CANCELED":
            case "EXPIRED":
            default :
                
                $order['customer_notified'] = 0;
                $order['order_status'] = $method->status_canceled;
                $order['comments'] = $pagadito_data["pending_reason"];
                break;
        }
        /* ACTUALIZAR ESTATUS DE LA ORDEN */
        $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
        /* DEVOLVER RESPUESTA */
        $payment_name = $this->renderPluginName($method);
        $html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);
        //We delete the old stuff
        // get the correct cart / session
        $cart = VirtueMartCart::getCart();
        $cart->emptyCart();
        return true;
    }

    function plgVmOnUserPaymentCancel($order_number, $virtuemart_paymentmethod_id) {
        if (!class_exists('VirtueMartModelOrders'))
            require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
        
        if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id)) {
            return null;
        }
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
            return null;
        }
        
        VmInfo(Jtext::_('VMPAYMENT_PAGADITO_PAYMENT_CANCELLED'));
        $session = JFactory::getSession();
        $return_context = $session->getId();
        $this->handlePaymentUserCancel($virtuemart_order_id);
        return true;
    }

    function _storePagaditoInternalData($method, $pagadito_data, $virtuemart_order_id, $order_number) {

        // get all know columns of the table
        $db = JFactory::getDBO();
        $query = 'SHOW COLUMNS FROM `' . $this->_tablename . '` ';
        $db->setQuery($query);
        $columns = $db->loadColumn(0);
        $post_msg = '';
        foreach ($pagadito_data as $key => $value) {
            $post_msg .= $key . "=" . $value . "<br />";
            $table_key = 'pagadito_response_' . $key;
            if (in_array($table_key, $columns)) {
                $response_fields[$table_key] = $value;
            }
        }
        $response_fields['payment_name'] = $this->renderPluginName($method);
        $response_fields['order_number'] = $order_number;
        $response_fields['virtuemart_order_id'] = $virtuemart_order_id;
        $this->storePSPluginInternalData($response_fields, 'virtuemart_order_id', true);
    }

    function _getTablepkeyValue($virtuemart_order_id) {
        $db = JFactory::getDBO();
        $q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
                . 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
        $db->setQuery($q);

        if (!($pkey = $db->loadResult())) {
            JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        return $pkey;
    }

    /**
     * Display stored payment data for an order
     * @see components/com_virtuemart/helpers/vmPSPlugin::plgVmOnShowOrderBEPayment()
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

        if (!$this->selectedThisByMethodId($payment_method_id)) {
            return null; // Another method was selected, do nothing
        }


        if (!($paymentTable = $this->_getPagaditoInternalData($virtuemart_order_id) )) {
            return '';
        }
        $this->getPaymentCurrency($paymentTable);
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
        $db = JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();
        $html = '<table class="adminlist">' . "\n";
        $html .=$this->getHtmlHeaderBE();
        $html .= $this->getHtmlRowBE('PAGADITO_PAYMENT_NAME', $paymentTable->payment_name);
        $code = "pagadito_response_";
        foreach ($paymentTable as $key => $value) {
            if (substr($key, 0, strlen($code)) == $code) {
                $html .= $this->getHtmlRowBE($key, $value);
            }
        }
        $html .= '</table>' . "\n";
        return $html;
    }

    function _getPagaditoInternalData($virtuemart_order_id, $order_number = '') {
        $db = JFactory::getDBO();
        $q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
        if ($order_number) {
            $q .= " `order_number` = '" . $order_number . "'";
        } else {
            $q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
        }

        $db->setQuery($q);
        if (!($paymentTable = $db->loadObject())) {
            // JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        return $paymentTable;
    }

    function _getMerchantUID($method) {
        return $method->sandbox ? $method->pagadito_sandbox_uid : $method->pagadito_uid;
    }

    function _getMerchantWSK($method) {
        return $method->sandbox ? $method->pagadito_sandbox_wsk : $method->pagadito_wsk;
    }

    function _getPaymentResponseHtml($pagaditoTable, $payment_name) {

        $html = '<table>' . "\n";
        $html .= $this->getHtmlRow('PAGADITO_PAYMENT_NAME', $payment_name);
        if (!empty($pagaditoTable)) {
            $html .= $this->getHtmlRow('PAGADITO_ORDER_NUMBER', $pagaditoTable->order_number);
        }
        $html .= '</table>' . "\n";

        return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    /**
     * Check if the payment conditions are fulfilled for this payment method
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
    protected function checkConditions($cart, $method, $cart_prices) {
        $this->convert($method);

        $address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

        $amount = $cart_prices['salesPrice'];
        $amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
                OR
                ($method->min_amount <= $amount AND ($method->max_amount == 0) ));

        $countries = array();
        if (!empty($method->countries)) {
            if (!is_array($method->countries)) {
                $countries[0] = $method->countries;
            } else {
                $countries = $method->countries;
            }
        }
        // probably did not gave his BT:ST address
        if (!is_array($address)) {
            $address = array();
            $address['virtuemart_country_id'] = 0;
        }

        if (!isset($address['virtuemart_country_id']))
            $address['virtuemart_country_id'] = 0;
        if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
            if ($amount_cond) {
                return true;
            }
        }

        return false;
    }

    function convert($method) {

        $method->min_amount = (float) $method->min_amount;
        $method->max_amount = (float) $method->max_amount;
    }

    /**
     * We must reimplement this triggers for joomla 1.7
     */

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     * @author Valérie Isaksen
     *
     */
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     *
     * @author Max Milbers
     * @author Valérie isaksen
     *
     * @param VirtueMartCart $cart: the actual cart
     * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
     *
     */
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
        return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    /*
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {
        return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers
     */
      public function plgVmOnCheckoutCheckDataPayment(VirtueMartCart $cart) {
      return null;
      }

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    /**
     * Save updated order data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk
     */
      public function plgVmOnUpdateOrderPayment($data, $old_order_status) {
      return null;
      }

    /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk
    */
    function plgVmOnUpdateOrderLine($data, $old_order_status) {
      return null;
    }

    /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk
    */
      public function plgVmOnEditOrderLineBE(  $_orderId, $_lineId) {
      return null;
      }

    /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk
    */
      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

    public function plgVmDeclarePluginParamsPaymentVM3( &$data) {
        return $this->declarePluginParams('payment', $data);
    }    
}
// No closing tag